<?php

namespace fk_\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCariBelgesi ArrayType
 * @subpackage Arrays
 */
class ArrayOfCariBelgesi extends AbstractStructArrayBase
{
    /**
     * The CariBelgesi
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \fk_\StructType\CariBelgesi[]
     */
    public $CariBelgesi;
    /**
     * Constructor method for ArrayOfCariBelgesi
     * @uses ArrayOfCariBelgesi::setCariBelgesi()
     * @param \fk_\StructType\CariBelgesi[] $cariBelgesi
     */
    public function __construct(array $cariBelgesi = array())
    {
        $this
            ->setCariBelgesi($cariBelgesi);
    }
    /**
     * Get CariBelgesi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \fk_\StructType\CariBelgesi[]|null
     */
    public function getCariBelgesi()
    {
        return isset($this->CariBelgesi) ? $this->CariBelgesi : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCariBelgesi method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCariBelgesi method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCariBelgesiForArrayConstraintsFromSetCariBelgesi(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCariBelgesiCariBelgesiItem) {
            // validation for constraint: itemType
            if (!$arrayOfCariBelgesiCariBelgesiItem instanceof \fk_\StructType\CariBelgesi) {
                $invalidValues[] = is_object($arrayOfCariBelgesiCariBelgesiItem) ? get_class($arrayOfCariBelgesiCariBelgesiItem) : sprintf('%s(%s)', gettype($arrayOfCariBelgesiCariBelgesiItem), var_export($arrayOfCariBelgesiCariBelgesiItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CariBelgesi property can only contain items of type \fk_\StructType\CariBelgesi, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CariBelgesi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\CariBelgesi[] $cariBelgesi
     * @return \fk_\ArrayType\ArrayOfCariBelgesi
     */
    public function setCariBelgesi(array $cariBelgesi = array())
    {
        // validation for constraint: array
        if ('' !== ($cariBelgesiArrayErrorMessage = self::validateCariBelgesiForArrayConstraintsFromSetCariBelgesi($cariBelgesi))) {
            throw new \InvalidArgumentException($cariBelgesiArrayErrorMessage, __LINE__);
        }
        if (is_null($cariBelgesi) || (is_array($cariBelgesi) && empty($cariBelgesi))) {
            unset($this->CariBelgesi);
        } else {
            $this->CariBelgesi = $cariBelgesi;
        }
        return $this;
    }
    /**
     * Add item to CariBelgesi value
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\CariBelgesi $item
     * @return \fk_\ArrayType\ArrayOfCariBelgesi
     */
    public function addToCariBelgesi(\fk_\StructType\CariBelgesi $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \fk_\StructType\CariBelgesi) {
            throw new \InvalidArgumentException(sprintf('The CariBelgesi property can only contain items of type \fk_\StructType\CariBelgesi, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CariBelgesi[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \fk_\StructType\CariBelgesi|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \fk_\StructType\CariBelgesi|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \fk_\StructType\CariBelgesi|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \fk_\StructType\CariBelgesi|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \fk_\StructType\CariBelgesi|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CariBelgesi
     */
    public function getAttributeName()
    {
        return 'CariBelgesi';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\ArrayType\ArrayOfCariBelgesi
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
