<?php

namespace fk_\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCariFisiSatiri ArrayType
 * @subpackage Arrays
 */
class ArrayOfCariFisiSatiri extends AbstractStructArrayBase
{
    /**
     * The CariFisiSatiri
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \fk_\StructType\CariFisiSatiri[]
     */
    public $CariFisiSatiri;
    /**
     * Constructor method for ArrayOfCariFisiSatiri
     * @uses ArrayOfCariFisiSatiri::setCariFisiSatiri()
     * @param \fk_\StructType\CariFisiSatiri[] $cariFisiSatiri
     */
    public function __construct(array $cariFisiSatiri = array())
    {
        $this
            ->setCariFisiSatiri($cariFisiSatiri);
    }
    /**
     * Get CariFisiSatiri value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \fk_\StructType\CariFisiSatiri[]|null
     */
    public function getCariFisiSatiri()
    {
        return isset($this->CariFisiSatiri) ? $this->CariFisiSatiri : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCariFisiSatiri method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCariFisiSatiri method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCariFisiSatiriForArrayConstraintsFromSetCariFisiSatiri(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCariFisiSatiriCariFisiSatiriItem) {
            // validation for constraint: itemType
            if (!$arrayOfCariFisiSatiriCariFisiSatiriItem instanceof \fk_\StructType\CariFisiSatiri) {
                $invalidValues[] = is_object($arrayOfCariFisiSatiriCariFisiSatiriItem) ? get_class($arrayOfCariFisiSatiriCariFisiSatiriItem) : sprintf('%s(%s)', gettype($arrayOfCariFisiSatiriCariFisiSatiriItem), var_export($arrayOfCariFisiSatiriCariFisiSatiriItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CariFisiSatiri property can only contain items of type \fk_\StructType\CariFisiSatiri, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CariFisiSatiri value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\CariFisiSatiri[] $cariFisiSatiri
     * @return \fk_\ArrayType\ArrayOfCariFisiSatiri
     */
    public function setCariFisiSatiri(array $cariFisiSatiri = array())
    {
        // validation for constraint: array
        if ('' !== ($cariFisiSatiriArrayErrorMessage = self::validateCariFisiSatiriForArrayConstraintsFromSetCariFisiSatiri($cariFisiSatiri))) {
            throw new \InvalidArgumentException($cariFisiSatiriArrayErrorMessage, __LINE__);
        }
        if (is_null($cariFisiSatiri) || (is_array($cariFisiSatiri) && empty($cariFisiSatiri))) {
            unset($this->CariFisiSatiri);
        } else {
            $this->CariFisiSatiri = $cariFisiSatiri;
        }
        return $this;
    }
    /**
     * Add item to CariFisiSatiri value
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\CariFisiSatiri $item
     * @return \fk_\ArrayType\ArrayOfCariFisiSatiri
     */
    public function addToCariFisiSatiri(\fk_\StructType\CariFisiSatiri $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \fk_\StructType\CariFisiSatiri) {
            throw new \InvalidArgumentException(sprintf('The CariFisiSatiri property can only contain items of type \fk_\StructType\CariFisiSatiri, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CariFisiSatiri[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \fk_\StructType\CariFisiSatiri|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \fk_\StructType\CariFisiSatiri|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \fk_\StructType\CariFisiSatiri|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \fk_\StructType\CariFisiSatiri|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \fk_\StructType\CariFisiSatiri|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CariFisiSatiri
     */
    public function getAttributeName()
    {
        return 'CariFisiSatiri';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\ArrayType\ArrayOfCariFisiSatiri
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
