<?php

namespace fk_\EnumType;

/**
 * This class stands for FATTES EnumType
 * @subpackage Enumerations
 */
class FATTES
{
    /**
     * Constant for value 'Tesellum'
     * @return string 'Tesellum'
     */
    const VALUE_TESELLUM = 'Tesellum';
    /**
     * Constant for value 'Fatura'
     * @return string 'Fatura'
     */
    const VALUE_FATURA = 'Fatura';
    /**
     * Constant for value 'TopluTasimaIrsaliye'
     * @return string 'TopluTasimaIrsaliye'
     */
    const VALUE_TOPLU_TASIMA_IRSALIYE = 'TopluTasimaIrsaliye';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_TESELLUM
     * @uses self::VALUE_FATURA
     * @uses self::VALUE_TOPLU_TASIMA_IRSALIYE
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_TESELLUM,
            self::VALUE_FATURA,
            self::VALUE_TOPLU_TASIMA_IRSALIYE,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
