<?php

namespace fk_\EnumType;

/**
 * This class stands for HatTip EnumType
 * @subpackage Enumerations
 */
class HatTip
{
    /**
     * Constant for value 'SubeAktarma'
     * @return string 'SubeAktarma'
     */
    const VALUE_SUBE_AKTARMA = 'SubeAktarma';
    /**
     * Constant for value 'AnaHat'
     * @return string 'AnaHat'
     */
    const VALUE_ANA_HAT = 'AnaHat';
    /**
     * Constant for value 'AraHat'
     * @return string 'AraHat'
     */
    const VALUE_ARA_HAT = 'AraHat';
    /**
     * Constant for value 'Dagitim'
     * @return string 'Dagitim'
     */
    const VALUE_DAGITIM = 'Dagitim';
    /**
     * Constant for value 'AktarmaSube'
     * @return string 'AktarmaSube'
     */
    const VALUE_AKTARMA_SUBE = 'AktarmaSube';
    /**
     * Constant for value 'AktarmaRing'
     * @return string 'AktarmaRing'
     */
    const VALUE_AKTARMA_RING = 'AktarmaRing';
    /**
     * Constant for value 'LojistikRing'
     * @return string 'LojistikRing'
     */
    const VALUE_LOJISTIK_RING = 'LojistikRing';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_SUBE_AKTARMA
     * @uses self::VALUE_ANA_HAT
     * @uses self::VALUE_ARA_HAT
     * @uses self::VALUE_DAGITIM
     * @uses self::VALUE_AKTARMA_SUBE
     * @uses self::VALUE_AKTARMA_RING
     * @uses self::VALUE_LOJISTIK_RING
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_SUBE_AKTARMA,
            self::VALUE_ANA_HAT,
            self::VALUE_ARA_HAT,
            self::VALUE_DAGITIM,
            self::VALUE_AKTARMA_SUBE,
            self::VALUE_AKTARMA_RING,
            self::VALUE_LOJISTIK_RING,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
