<?php

namespace fk_\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KTesellum StructType
 * @subpackage Structs
 */
class KTesellum extends TESFAT
{
    /**
     * The TesellumTuru
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $TesellumTuru;
    /**
     * The OdemeSekli
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $OdemeSekli;
    /**
     * The TATNo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $TATNo;
    /**
     * The IsHizliTesellumEvrak
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsHizliTesellumEvrak;
    /**
     * The IsKampanyaSozlemesiKullanabilir
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsKampanyaSozlemesiKullanabilir;
    /**
     * The IadeMi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IadeMi;
    /**
     * The IsEphHesaplansin
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsEphHesaplansin;
    /**
     * The Faturasi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\KFaturaPointer
     */
    public $Faturasi;
    /**
     * The FaturalayacakSube
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\KSubePointer
     */
    public $FaturalayacakSube;
    /**
     * The IadeTesellum
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\KTesellumPointer
     */
    public $IadeTesellum;
    /**
     * The KampanyaSifresi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $KampanyaSifresi;
    /**
     * The TesellumEkBilgi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\KTesellumEkBilgi
     */
    public $TesellumEkBilgi;
    /**
     * Constructor method for KTesellum
     * @uses KTesellum::setTesellumTuru()
     * @uses KTesellum::setOdemeSekli()
     * @uses KTesellum::setTATNo()
     * @uses KTesellum::setIsHizliTesellumEvrak()
     * @uses KTesellum::setIsKampanyaSozlemesiKullanabilir()
     * @uses KTesellum::setIadeMi()
     * @uses KTesellum::setIsEphHesaplansin()
     * @uses KTesellum::setFaturasi()
     * @uses KTesellum::setFaturalayacakSube()
     * @uses KTesellum::setIadeTesellum()
     * @uses KTesellum::setKampanyaSifresi()
     * @uses KTesellum::setTesellumEkBilgi()
     * @param string $tesellumTuru
     * @param string $odemeSekli
     * @param int $tATNo
     * @param bool $isHizliTesellumEvrak
     * @param bool $isKampanyaSozlemesiKullanabilir
     * @param bool $iadeMi
     * @param bool $isEphHesaplansin
     * @param \fk_\StructType\KFaturaPointer $faturasi
     * @param \fk_\StructType\KSubePointer $faturalayacakSube
     * @param \fk_\StructType\KTesellumPointer $iadeTesellum
     * @param string $kampanyaSifresi
     * @param \fk_\StructType\KTesellumEkBilgi $tesellumEkBilgi
     */
    public function __construct($tesellumTuru = null, $odemeSekli = null, $tATNo = null, $isHizliTesellumEvrak = null, $isKampanyaSozlemesiKullanabilir = null, $iadeMi = null, $isEphHesaplansin = null, \fk_\StructType\KFaturaPointer $faturasi = null, \fk_\StructType\KSubePointer $faturalayacakSube = null, \fk_\StructType\KTesellumPointer $iadeTesellum = null, $kampanyaSifresi = null, \fk_\StructType\KTesellumEkBilgi $tesellumEkBilgi = null)
    {
        $this
            ->setTesellumTuru($tesellumTuru)
            ->setOdemeSekli($odemeSekli)
            ->setTATNo($tATNo)
            ->setIsHizliTesellumEvrak($isHizliTesellumEvrak)
            ->setIsKampanyaSozlemesiKullanabilir($isKampanyaSozlemesiKullanabilir)
            ->setIadeMi($iadeMi)
            ->setIsEphHesaplansin($isEphHesaplansin)
            ->setFaturasi($faturasi)
            ->setFaturalayacakSube($faturalayacakSube)
            ->setIadeTesellum($iadeTesellum)
            ->setKampanyaSifresi($kampanyaSifresi)
            ->setTesellumEkBilgi($tesellumEkBilgi);
    }
    /**
     * Get TesellumTuru value
     * @return string
     */
    public function getTesellumTuru()
    {
        return $this->TesellumTuru;
    }
    /**
     * Set TesellumTuru value
     * @uses \fk_\EnumType\KEvrakTurleri::valueIsValid()
     * @uses \fk_\EnumType\KEvrakTurleri::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $tesellumTuru
     * @return \fk_\StructType\KTesellum
     */
    public function setTesellumTuru($tesellumTuru = null)
    {
        // validation for constraint: enumeration
        if (!\fk_\EnumType\KEvrakTurleri::valueIsValid($tesellumTuru)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \fk_\EnumType\KEvrakTurleri', is_array($tesellumTuru) ? implode(', ', $tesellumTuru) : var_export($tesellumTuru, true), implode(', ', \fk_\EnumType\KEvrakTurleri::getValidValues())), __LINE__);
        }
        $this->TesellumTuru = $tesellumTuru;
        return $this;
    }
    /**
     * Get OdemeSekli value
     * @return string
     */
    public function getOdemeSekli()
    {
        return $this->OdemeSekli;
    }
    /**
     * Set OdemeSekli value
     * @uses \fk_\EnumType\KTesellumOdemeSekli::valueIsValid()
     * @uses \fk_\EnumType\KTesellumOdemeSekli::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $odemeSekli
     * @return \fk_\StructType\KTesellum
     */
    public function setOdemeSekli($odemeSekli = null)
    {
        // validation for constraint: enumeration
        if (!\fk_\EnumType\KTesellumOdemeSekli::valueIsValid($odemeSekli)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \fk_\EnumType\KTesellumOdemeSekli', is_array($odemeSekli) ? implode(', ', $odemeSekli) : var_export($odemeSekli, true), implode(', ', \fk_\EnumType\KTesellumOdemeSekli::getValidValues())), __LINE__);
        }
        $this->OdemeSekli = $odemeSekli;
        return $this;
    }
    /**
     * Get TATNo value
     * @return int
     */
    public function getTATNo()
    {
        return $this->TATNo;
    }
    /**
     * Set TATNo value
     * @param int $tATNo
     * @return \fk_\StructType\KTesellum
     */
    public function setTATNo($tATNo = null)
    {
        // validation for constraint: int
        if (!is_null($tATNo) && !(is_int($tATNo) || ctype_digit($tATNo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($tATNo, true), gettype($tATNo)), __LINE__);
        }
        $this->TATNo = $tATNo;
        return $this;
    }
    /**
     * Get IsHizliTesellumEvrak value
     * @return bool
     */
    public function getIsHizliTesellumEvrak()
    {
        return $this->IsHizliTesellumEvrak;
    }
    /**
     * Set IsHizliTesellumEvrak value
     * @param bool $isHizliTesellumEvrak
     * @return \fk_\StructType\KTesellum
     */
    public function setIsHizliTesellumEvrak($isHizliTesellumEvrak = null)
    {
        // validation for constraint: boolean
        if (!is_null($isHizliTesellumEvrak) && !is_bool($isHizliTesellumEvrak)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isHizliTesellumEvrak, true), gettype($isHizliTesellumEvrak)), __LINE__);
        }
        $this->IsHizliTesellumEvrak = $isHizliTesellumEvrak;
        return $this;
    }
    /**
     * Get IsKampanyaSozlemesiKullanabilir value
     * @return bool
     */
    public function getIsKampanyaSozlemesiKullanabilir()
    {
        return $this->IsKampanyaSozlemesiKullanabilir;
    }
    /**
     * Set IsKampanyaSozlemesiKullanabilir value
     * @param bool $isKampanyaSozlemesiKullanabilir
     * @return \fk_\StructType\KTesellum
     */
    public function setIsKampanyaSozlemesiKullanabilir($isKampanyaSozlemesiKullanabilir = null)
    {
        // validation for constraint: boolean
        if (!is_null($isKampanyaSozlemesiKullanabilir) && !is_bool($isKampanyaSozlemesiKullanabilir)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isKampanyaSozlemesiKullanabilir, true), gettype($isKampanyaSozlemesiKullanabilir)), __LINE__);
        }
        $this->IsKampanyaSozlemesiKullanabilir = $isKampanyaSozlemesiKullanabilir;
        return $this;
    }
    /**
     * Get IadeMi value
     * @return bool
     */
    public function getIadeMi()
    {
        return $this->IadeMi;
    }
    /**
     * Set IadeMi value
     * @param bool $iadeMi
     * @return \fk_\StructType\KTesellum
     */
    public function setIadeMi($iadeMi = null)
    {
        // validation for constraint: boolean
        if (!is_null($iadeMi) && !is_bool($iadeMi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($iadeMi, true), gettype($iadeMi)), __LINE__);
        }
        $this->IadeMi = $iadeMi;
        return $this;
    }
    /**
     * Get IsEphHesaplansin value
     * @return bool
     */
    public function getIsEphHesaplansin()
    {
        return $this->IsEphHesaplansin;
    }
    /**
     * Set IsEphHesaplansin value
     * @param bool $isEphHesaplansin
     * @return \fk_\StructType\KTesellum
     */
    public function setIsEphHesaplansin($isEphHesaplansin = null)
    {
        // validation for constraint: boolean
        if (!is_null($isEphHesaplansin) && !is_bool($isEphHesaplansin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isEphHesaplansin, true), gettype($isEphHesaplansin)), __LINE__);
        }
        $this->IsEphHesaplansin = $isEphHesaplansin;
        return $this;
    }
    /**
     * Get Faturasi value
     * @return \fk_\StructType\KFaturaPointer|null
     */
    public function getFaturasi()
    {
        return $this->Faturasi;
    }
    /**
     * Set Faturasi value
     * @param \fk_\StructType\KFaturaPointer $faturasi
     * @return \fk_\StructType\KTesellum
     */
    public function setFaturasi(\fk_\StructType\KFaturaPointer $faturasi = null)
    {
        $this->Faturasi = $faturasi;
        return $this;
    }
    /**
     * Get FaturalayacakSube value
     * @return \fk_\StructType\KSubePointer|null
     */
    public function getFaturalayacakSube()
    {
        return $this->FaturalayacakSube;
    }
    /**
     * Set FaturalayacakSube value
     * @param \fk_\StructType\KSubePointer $faturalayacakSube
     * @return \fk_\StructType\KTesellum
     */
    public function setFaturalayacakSube(\fk_\StructType\KSubePointer $faturalayacakSube = null)
    {
        $this->FaturalayacakSube = $faturalayacakSube;
        return $this;
    }
    /**
     * Get IadeTesellum value
     * @return \fk_\StructType\KTesellumPointer|null
     */
    public function getIadeTesellum()
    {
        return $this->IadeTesellum;
    }
    /**
     * Set IadeTesellum value
     * @param \fk_\StructType\KTesellumPointer $iadeTesellum
     * @return \fk_\StructType\KTesellum
     */
    public function setIadeTesellum(\fk_\StructType\KTesellumPointer $iadeTesellum = null)
    {
        $this->IadeTesellum = $iadeTesellum;
        return $this;
    }
    /**
     * Get KampanyaSifresi value
     * @return string|null
     */
    public function getKampanyaSifresi()
    {
        return $this->KampanyaSifresi;
    }
    /**
     * Set KampanyaSifresi value
     * @param string $kampanyaSifresi
     * @return \fk_\StructType\KTesellum
     */
    public function setKampanyaSifresi($kampanyaSifresi = null)
    {
        // validation for constraint: string
        if (!is_null($kampanyaSifresi) && !is_string($kampanyaSifresi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kampanyaSifresi, true), gettype($kampanyaSifresi)), __LINE__);
        }
        $this->KampanyaSifresi = $kampanyaSifresi;
        return $this;
    }
    /**
     * Get TesellumEkBilgi value
     * @return \fk_\StructType\KTesellumEkBilgi|null
     */
    public function getTesellumEkBilgi()
    {
        return $this->TesellumEkBilgi;
    }
    /**
     * Set TesellumEkBilgi value
     * @param \fk_\StructType\KTesellumEkBilgi $tesellumEkBilgi
     * @return \fk_\StructType\KTesellum
     */
    public function setTesellumEkBilgi(\fk_\StructType\KTesellumEkBilgi $tesellumEkBilgi = null)
    {
        $this->TesellumEkBilgi = $tesellumEkBilgi;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\StructType\KTesellum
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
