<?php

namespace fk_\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SistemBilgileri StructType
 * @subpackage Structs
 */
class SistemBilgileri extends ValueEntity
{
    /**
     * The InsertTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $InsertTime;
    /**
     * The UpdateTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $UpdateTime;
    /**
     * The Timestamp
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Timestamp;
    /**
     * The InsertLogin
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InsertLogin;
    /**
     * The TransactionId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransactionId;
    /**
     * The UpdateLogin
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UpdateLogin;
    /**
     * The InsertTerminal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InsertTerminal;
    /**
     * The UpdateTerminal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UpdateTerminal;
    /**
     * Constructor method for SistemBilgileri
     * @uses SistemBilgileri::setInsertTime()
     * @uses SistemBilgileri::setUpdateTime()
     * @uses SistemBilgileri::setTimestamp()
     * @uses SistemBilgileri::setInsertLogin()
     * @uses SistemBilgileri::setTransactionId()
     * @uses SistemBilgileri::setUpdateLogin()
     * @uses SistemBilgileri::setInsertTerminal()
     * @uses SistemBilgileri::setUpdateTerminal()
     * @param string $insertTime
     * @param string $updateTime
     * @param string $timestamp
     * @param string $insertLogin
     * @param string $transactionId
     * @param string $updateLogin
     * @param string $insertTerminal
     * @param string $updateTerminal
     */
    public function __construct($insertTime = null, $updateTime = null, $timestamp = null, $insertLogin = null, $transactionId = null, $updateLogin = null, $insertTerminal = null, $updateTerminal = null)
    {
        $this
            ->setInsertTime($insertTime)
            ->setUpdateTime($updateTime)
            ->setTimestamp($timestamp)
            ->setInsertLogin($insertLogin)
            ->setTransactionId($transactionId)
            ->setUpdateLogin($updateLogin)
            ->setInsertTerminal($insertTerminal)
            ->setUpdateTerminal($updateTerminal);
    }
    /**
     * Get InsertTime value
     * @return string
     */
    public function getInsertTime()
    {
        return $this->InsertTime;
    }
    /**
     * Set InsertTime value
     * @param string $insertTime
     * @return \fk_\StructType\SistemBilgileri
     */
    public function setInsertTime($insertTime = null)
    {
        // validation for constraint: string
        if (!is_null($insertTime) && !is_string($insertTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($insertTime, true), gettype($insertTime)), __LINE__);
        }
        $this->InsertTime = $insertTime;
        return $this;
    }
    /**
     * Get UpdateTime value
     * @return string
     */
    public function getUpdateTime()
    {
        return $this->UpdateTime;
    }
    /**
     * Set UpdateTime value
     * @param string $updateTime
     * @return \fk_\StructType\SistemBilgileri
     */
    public function setUpdateTime($updateTime = null)
    {
        // validation for constraint: string
        if (!is_null($updateTime) && !is_string($updateTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateTime, true), gettype($updateTime)), __LINE__);
        }
        $this->UpdateTime = $updateTime;
        return $this;
    }
    /**
     * Get Timestamp value
     * @return string|null
     */
    public function getTimestamp()
    {
        return $this->Timestamp;
    }
    /**
     * Set Timestamp value
     * @param string $timestamp
     * @return \fk_\StructType\SistemBilgileri
     */
    public function setTimestamp($timestamp = null)
    {
        // validation for constraint: string
        if (!is_null($timestamp) && !is_string($timestamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($timestamp, true), gettype($timestamp)), __LINE__);
        }
        $this->Timestamp = $timestamp;
        return $this;
    }
    /**
     * Get InsertLogin value
     * @return string|null
     */
    public function getInsertLogin()
    {
        return $this->InsertLogin;
    }
    /**
     * Set InsertLogin value
     * @param string $insertLogin
     * @return \fk_\StructType\SistemBilgileri
     */
    public function setInsertLogin($insertLogin = null)
    {
        // validation for constraint: string
        if (!is_null($insertLogin) && !is_string($insertLogin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($insertLogin, true), gettype($insertLogin)), __LINE__);
        }
        $this->InsertLogin = $insertLogin;
        return $this;
    }
    /**
     * Get TransactionId value
     * @return string|null
     */
    public function getTransactionId()
    {
        return $this->TransactionId;
    }
    /**
     * Set TransactionId value
     * @param string $transactionId
     * @return \fk_\StructType\SistemBilgileri
     */
    public function setTransactionId($transactionId = null)
    {
        // validation for constraint: string
        if (!is_null($transactionId) && !is_string($transactionId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionId, true), gettype($transactionId)), __LINE__);
        }
        $this->TransactionId = $transactionId;
        return $this;
    }
    /**
     * Get UpdateLogin value
     * @return string|null
     */
    public function getUpdateLogin()
    {
        return $this->UpdateLogin;
    }
    /**
     * Set UpdateLogin value
     * @param string $updateLogin
     * @return \fk_\StructType\SistemBilgileri
     */
    public function setUpdateLogin($updateLogin = null)
    {
        // validation for constraint: string
        if (!is_null($updateLogin) && !is_string($updateLogin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateLogin, true), gettype($updateLogin)), __LINE__);
        }
        $this->UpdateLogin = $updateLogin;
        return $this;
    }
    /**
     * Get InsertTerminal value
     * @return string|null
     */
    public function getInsertTerminal()
    {
        return $this->InsertTerminal;
    }
    /**
     * Set InsertTerminal value
     * @param string $insertTerminal
     * @return \fk_\StructType\SistemBilgileri
     */
    public function setInsertTerminal($insertTerminal = null)
    {
        // validation for constraint: string
        if (!is_null($insertTerminal) && !is_string($insertTerminal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($insertTerminal, true), gettype($insertTerminal)), __LINE__);
        }
        $this->InsertTerminal = $insertTerminal;
        return $this;
    }
    /**
     * Get UpdateTerminal value
     * @return string|null
     */
    public function getUpdateTerminal()
    {
        return $this->UpdateTerminal;
    }
    /**
     * Set UpdateTerminal value
     * @param string $updateTerminal
     * @return \fk_\StructType\SistemBilgileri
     */
    public function setUpdateTerminal($updateTerminal = null)
    {
        // validation for constraint: string
        if (!is_null($updateTerminal) && !is_string($updateTerminal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateTerminal, true), gettype($updateTerminal)), __LINE__);
        }
        $this->UpdateTerminal = $updateTerminal;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\StructType\SistemBilgileri
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
